# Juju wordpress charm

The wordpress charm will deploy a WordPress blog.
The charm relates to subordinate charms implementing `webservice` relation
which will in turn install and configure a web server.
The wordpress charm also relates to the wordpress-plugin and wordpress-theme
subordinate charms using `wordpress-plugin` and `wordpress-theme` relations

## How to deploy the charm

Assuming you have a copy of the wordpress charm in
`./charms/$distrocodename/wordpress`:

    juju deploy --repository=charms local:wordpress

The charm uses the `webservice` relation with a subordinate HTTP server. For
example if you have apache2-subordinate charm deployed as
`apache2-subordinate` service you can ask apache to host wordpress like
this:

    juju add-relation wordpress apache2-subordinate

## How to add plugins

Plugins can be deployed using the `wordpress-plugin` subordinate charm.
For example if you deployed the openid plugin as a subordinate service
named `wp-plugin-openid`, you can add it to the `wordpress` service like
this:

    juju add-relation wordpress wp-plugin-openid

## How to deploy themes

Themes can be deployed using wordpress-theme subordinate charm.
For example if you deployed your `my-enterprise` theme as
`wp-theme-enterprise` service, you can add it to your blog like this:

    juju add-relation wordpress wp-theme-enterprise

## Horizontal scaling

Horizontal scaling depends on media files being available on all service
units.  The recommended way to achieve this on OpenStack clouds is to use
the OpenStack object storage plugin:

    lp:~canonical-sysadmins/wordpress/openstack-objectstorage

When the plugin is configured and active, new units can be added like this:

    juju add-unit wordpress

Or to do multiple units at once:

    juju add-unit -n 4 wordpress

## Notes about security

This charm was designed with security in mind. Because of this WordPress
has very limited access to the host operating system filesystem.
Most notably it will not be possible to install plugins and themes
using WordPress's admin control panel.

Plugins and themes can be added to the environment using subordinate charms

## TODO

    * Find some technology (like FPM) that allows us to run PHP in a separate memory space from the Web browser.  This may be an argument in favour of nginx
